<html>
<head>
<title>OgreShaderProgramManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderProgramManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderProgramManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderProgramManager_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderProgramManager_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderProgram_8h.html">OgreShaderProgram.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderProgramWriter_8h.html">OgreShaderProgramWriter.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {    
<a name="l00035"></a>00035 <span class="keyword">namespace </span>RTShader {
<a name="l00036"></a>00036 
<a name="l00046"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html">00046</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html" title="A singleton manager class that manages shader based programs.">ProgramManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;ProgramManager&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="comment">// Interface.</span>
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00052"></a>00052     <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html" title="A singleton manager class that manages shader based programs.">ProgramManager</a>  ();
<a name="l00053"></a>00053 
<a name="l00055"></a>00055     ~<a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html" title="A singleton manager class that manages shader based programs.">ProgramManager</a> ();
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00073"></a>00073     <span class="keyword">static</span> <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html" title="A singleton manager class that manages shader based programs.">ProgramManager</a>&amp;          getSingleton    (); 
<a name="l00074"></a>00074 
<a name="l00090"></a>00090     <span class="keyword">static</span> <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html" title="A singleton manager class that manages shader based programs.">ProgramManager</a>*          getSingletonPtr             ();
<a name="l00091"></a>00091 
<a name="l00096"></a>00096     <span class="keywordtype">void</span>                            acquirePrograms         (<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pass, <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html" title="This is the target render state.">TargetRenderState</a>* renderState);
<a name="l00097"></a>00097 
<a name="l00102"></a>00102     <span class="keywordtype">void</span>                            releasePrograms         (<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pass, <a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html" title="This is the target render state.">TargetRenderState</a>* renderState);
<a name="l00103"></a>00103 
<a name="l00106"></a>00106     <span class="keywordtype">void</span>                            flushGpuProgramsCache   ();
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="keyword">protected</span>:
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00111"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">00111</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, GpuProgramPtr&gt;::type</a>            <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a>;
<a name="l00112"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a5b56328823eb9ab9d39823bfa2aa5746">00112</a>     <span class="keyword">typedef</span> GpuProgramsMap::iterator                    <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a5b56328823eb9ab9d39823bfa2aa5746">GpuProgramsMapIterator</a>;
<a name="l00113"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a399fd8dd25b5dd01096adcca41f584a9">00113</a>     <span class="keyword">typedef</span> GpuProgramsMap::const_iterator              <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a399fd8dd25b5dd01096adcca41f584a9">GpuProgramsMapConstIterator</a>;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115     <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00116"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a0f7df7b3bdf120c0b4e1f2fd69db5c99">00116</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;Program*&gt;::type</a>                         <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a0f7df7b3bdf120c0b4e1f2fd69db5c99">ProgramList</a>;
<a name="l00117"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae67ddfab3decd1b3823b2ba7de86d964">00117</a>     <span class="keyword">typedef</span> ProgramList::iterator                       <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae67ddfab3decd1b3823b2ba7de86d964">ProgramListIterator</a>;
<a name="l00118"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae5169c232806b070eb8983949fb2645b">00118</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, ProgramWriter*&gt;::type</a>           <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae5169c232806b070eb8983949fb2645b">ProgramWriterMap</a>;
<a name="l00119"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a516c14e5e1624f33e204e30d0f5d91b4">00119</a>     <span class="keyword">typedef</span> ProgramWriterMap::iterator                  <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a516c14e5e1624f33e204e30d0f5d91b4">ProgramWriterIterator</a>;
<a name="l00120"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef888e5ad925de6207cb5da3cad588f1">00120</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ProgramWriterFactory*&gt;::type</a>         <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef888e5ad925de6207cb5da3cad588f1">ProgramWriterFactoryList</a>;
<a name="l00121"></a>00121     
<a name="l00122"></a>00122     <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00123"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a587dec8ae6e0c2dfbdd2751da80549d6">00123</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, ProgramProcessor*&gt;::type</a>        <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a587dec8ae6e0c2dfbdd2751da80549d6">ProgramProcessorMap</a>;
<a name="l00124"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a09f6ad3178b190ca76bb5d6c3b5d1539">00124</a>     <span class="keyword">typedef</span> ProgramProcessorMap::iterator               <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a09f6ad3178b190ca76bb5d6c3b5d1539">ProgramProcessorIterator</a>;
<a name="l00125"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a828c6453d29c03242d8c2f8872048d4a">00125</a>     <span class="keyword">typedef</span> ProgramProcessorMap::const_iterator         <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a828c6453d29c03242d8c2f8872048d4a">ProgramProcessorConstIterator</a>;
<a name="l00126"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef6274f2febcceddbbf9e7cff003431d">00126</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ProgramProcessor*&gt;::type</a>             <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef6274f2febcceddbbf9e7cff003431d">ProgramProcessorList</a>;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     
<a name="l00129"></a>00129 <span class="keyword">protected</span>:
<a name="l00131"></a>00131     <span class="keywordtype">void</span>            createDefaultProgramProcessors  ();
<a name="l00132"></a>00132     
<a name="l00134"></a>00134     <span class="keywordtype">void</span>            destroyDefaultProgramProcessors ();
<a name="l00135"></a>00135 
<a name="l00137"></a>00137     <span class="keywordtype">void</span>            createDefaultProgramWriterFactories ();
<a name="l00138"></a>00138 
<a name="l00140"></a>00140     <span class="keywordtype">void</span>            destroyDefaultProgramWriterFactories();
<a name="l00141"></a>00141 
<a name="l00143"></a>00143     <span class="keywordtype">void</span>            destroyProgramWriters   ();
<a name="l00144"></a>00144 
<a name="l00148"></a>00148     <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>*        createCpuProgram        (<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> type);
<a name="l00149"></a>00149 
<a name="l00153"></a>00153     <span class="keywordtype">void</span>            destroyCpuProgram       (<a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* shaderProgram);
<a name="l00154"></a>00154 
<a name="l00158"></a>00158     <span class="keywordtype">bool</span>            createGpuPrograms       (<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* programSet);
<a name="l00159"></a>00159 
<a name="l00168"></a>00168     <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>   createGpuProgram        (<a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* shaderProgram, 
<a name="l00169"></a>00169         <a class="code" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers.">ProgramWriter</a>* programWriter,
<a name="l00170"></a>00170         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; language,
<a name="l00171"></a>00171         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profiles,
<a name="l00172"></a>00172         <span class="keyword">const</span> <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; profilesList,
<a name="l00173"></a>00173         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; cachePath);
<a name="l00174"></a>00174 
<a name="l00179"></a>00179     <span class="keywordtype">void</span>            addProgramProcessor     (<a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html" title="A class that provides extra processing services on CPU based programs.">ProgramProcessor</a>* processor);
<a name="l00180"></a>00180 
<a name="l00185"></a>00185     <span class="keywordtype">void</span>            removeProgramProcessor  (<a class="code" href="classOgre_1_1RTShader_1_1ProgramProcessor.html" title="A class that provides extra processing services on CPU based programs.">ProgramProcessor</a>* processor);
<a name="l00186"></a>00186 
<a name="l00191"></a>00191     <span class="keywordtype">void</span>            destroyGpuProgram       (<a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; gpuProgram);
<a name="l00192"></a>00192 
<a name="l00196"></a>00196     <span class="keywordtype">void</span>            flushGpuProgramsCache   (<a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a>&amp; gpuProgramsMap);
<a name="l00197"></a>00197     
<a name="l00199"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6520a083063012966afc4bdd4b7e8b56">00199</a>     <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6520a083063012966afc4bdd4b7e8b56" title="Return the number of created vertex shaders.">getVertexShaderCount</a>        ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexShaderMap.size(); }
<a name="l00200"></a>00200 
<a name="l00202"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#ada664dc10866e58c9825b70cdbe333e4">00202</a>     <span class="keywordtype">size_t</span>          <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#ada664dc10866e58c9825b70cdbe333e4" title="Return the number of created fragment shaders.">getFragmentShaderCount</a>      ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFragmentShaderMap.size(); }
<a name="l00203"></a>00203 
<a name="l00205"></a>00205     <span class="keywordtype">void</span>            synchronizePixelnToBeVertexOut  (<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* programSet);
<a name="l00206"></a>00206 
<a name="l00208"></a>00208     <span class="keywordtype">void</span>            bindUniformParameters           (<a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* pCpuProgram, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; passParams);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="keyword">protected</span>:
<a name="l00212"></a>00212     
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="keyword">protected</span>:
<a name="l00215"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a774e21edb65ca869e2d7fc5d39514bfa">00215</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a0f7df7b3bdf120c0b4e1f2fd69db5c99">ProgramList</a>                 <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a774e21edb65ca869e2d7fc5d39514bfa">mCpuProgramsList</a>;               <span class="comment">// CPU programs list.                   </span>
<a name="l00216"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#af3058fc76343ef0a2e4490d7ff7409e3">00216</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae5169c232806b070eb8983949fb2645b">ProgramWriterMap</a>            <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#af3058fc76343ef0a2e4490d7ff7409e3">mProgramWritersMap</a>;             <span class="comment">// Map between target language and shader program writer.                   </span>
<a name="l00217"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#afb4dc08057dbac666effe79c14541441">00217</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a587dec8ae6e0c2dfbdd2751da80549d6">ProgramProcessorMap</a>         <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#afb4dc08057dbac666effe79c14541441">mProgramProcessorsMap</a>;          <span class="comment">// Map between target language and shader program processor.    </span>
<a name="l00218"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a261d632268e484e4e29038488c3c82c4">00218</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef888e5ad925de6207cb5da3cad588f1">ProgramWriterFactoryList</a>    <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a261d632268e484e4e29038488c3c82c4">mProgramWriterFactories</a>;        <span class="comment">// Holds standard shader writer factories</span>
<a name="l00219"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a91ebd2a26c267914c4dbec827786ef65">00219</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a>              <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a91ebd2a26c267914c4dbec827786ef65">mVertexShaderMap</a>;               <span class="comment">// The generated vertex shaders.</span>
<a name="l00220"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a115511b28b8ad14d77df7e1d15691588">00220</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a>              <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#a115511b28b8ad14d77df7e1d15691588">mFragmentShaderMap</a>;             <span class="comment">// The generated fragment shaders.</span>
<a name="l00221"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#affb5afbd04566b7039f60bfd0f3b9bf2">00221</a>     <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef6274f2febcceddbbf9e7cff003431d">ProgramProcessorList</a>        <a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#affb5afbd04566b7039f60bfd0f3b9bf2">mDefaultProgramProcessors</a>;      <span class="comment">// The default program processors.</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="keyword">private</span>:
<a name="l00224"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#af4cc94a00f22d3cc0d2408ba30a9a141">00224</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>;
<a name="l00225"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#af6e59fb08a915c63d07d3e1a1a4f1092">00225</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1TargetRenderState.html" title="This is the target render state.">TargetRenderState</a>;
<a name="l00226"></a><a class="code" href="classOgre_1_1RTShader_1_1ProgramManager.html#adcb2ff432738c3d0e602910347d3785a">00226</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1ShaderGenerator.html" title="Shader generator system main interface.">ShaderGenerator</a>;
<a name="l00227"></a>00227 };
<a name="l00228"></a>00228 
<a name="l00232"></a>00232 }
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="preprocessor">#endif</span>
<a name="l00236"></a>00236 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
